#ifndef ALPATH_H_INCLUDED
#define ALPATH_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif
#include "../types.h"

typedef struct {
    char type[4 + 1];
    char group[26 + 1];
    char* name;
    char* path;
} alyson_path_t, *ALPath;

/*
 * @function: demangle_path
 * @description: Demangles a path
 * @param path: path to resource
 * @return: ALPath
 */
ALPath al_demangle_path(const char* path);
char* al_mangle_path(const ALPath path);
ALPath al_create_path(
    const char* type,
    const char* path,
    const char* name,
    const char* group
);
void al_destroy_path(ALPath path);

#ifdef __cplusplus
}
#endif

#endif // ALPATH_H_INCLUDED
